import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.awt.geom.*;
import java.math.*;


public class CalculationMonitor {
    int X,Y;
    double TIME,VOLUME,TOTAL;
    int STEPS;
    int[] AGE=new int[5];
    int[] MARKER=new int[2];
    

    public CalculationMonitor(int x,int y) {
	X=x;
	Y=y;
    }

    public void clear() {
	STEPS=0;
	for(int i=0;i<5;++i) AGE[i]=0;
	TIME=0;
    }

    public void render(Graphics2D g,boolean halt) {
	drawFrame(g,halt);
	g.setColor(Color.yellow);
	g.setFont(new Font("Helvetica",Font.PLAIN,15));
	g.drawString("calculation monitor",X+30,Y+17);
	  drawDimensions(g);
	  drawTime(g);
	  drawSteps(g);
	  drawProgress(g);
    }


    public void drawFrame(Graphics2D g,boolean halt) {
	g.setColor(new Color(0,0,255));
	if(halt==true) g.setColor(new Color(0,0,60));
	g.fillRect(X-5,Y,180,210);
	g.setColor(Color.white);
	g.drawRect(X-5,Y,180,210);
    }

    public void drawDimensions(Graphics2D g) {
	g.setFont(new Font("Helvetica",Font.PLAIN,15));
        g.setColor(Color.white);
        g.drawString("current age:",X,Y+40);
        for(int i=0;i<5;++i) {
	   g.drawString(convert(AGE[i]),X+20*i,Y+60);
       }
    }

    public void drawTime(Graphics2D g) {
	int[] A=convertTime(TIME);
	g.setFont(new Font("Helvetica",Font.PLAIN,15));
        g.setColor(Color.white);
	g.drawString("elapsed time",X,Y+90);
        g.drawString(convert(A[0])+" min",X,Y+110);
        g.drawString(convert(A[1])+" sec",X+57,Y+110);
    }

    public void drawSteps(Graphics2D g) {
	g.setFont(new Font("Helvetica",Font.PLAIN,15));
        g.setColor(Color.white);
        g.drawString("steps: "+convert(STEPS),X,Y+145);
    }

    public void drawProgress(Graphics2D g) {
	g.setFont(new Font("Helvetica",Font.PLAIN,15));
        g.setColor(Color.white);
	g.drawString("progress",X,Y+180);
        g.drawString(convert(VOLUME),X,Y+200);

    }

    public static int[] convertTime(double t) {
	double u1=t/1000;  //seconds
	double u2=Math.floor(u1/60); //minutes
	double u3=u1-60*u2;  
	int a=(int)(u2);
	int b=(int)(u3);
	int[] A={a,b};
	return(A);
    }

    public String convert(int a) {
	Integer A=new Integer(a);
	return(A.toString());
    }


    public String convert(double a) {
	Double A=new Double(a);
	return(A.toString());
    }

}

