

public class DocumentCertify {

    public DocumentCertify() {}


    public static void certify(DocumentCanvas D) {
	String S="certification mode";

	S=S+"\n\n This selection activitates the rigorous proving part of the computer program.  This mode works with the polynomial classes Poly5 and Poly6, which encode integer polynomials in 5 and 6 variables respectively.  The program is able to (sometimes) certify that an integer Poly6P is non-negative on an integer 5-simplex S in R^6.";

	S=S+"\n\nThe first step in the method is to produce a surjective polynomial map F:[0,1]^5 \u2192 S and then show that the Poly5 Q=PF is nonnegative on [0,1]^5. We write Q=\u2211 c_E x^E, where E is some multi-index and c_E is a coefficient.  The expression x^E means x1^e1...x5^e5. We always have ek \u2208 {0,1,2,3,4,5,6} and we use BigIntegers to represent the coefficients c_E.";

	S=S+"\n\nWe call Q weak positive dominant (WPD) if, for every multi-index J, we have\n\n(\u2211 c_E: E\u2264J) \u22640.\n\nHere E\u2264J means that e1\u2264j1,..., e5\u2264j5.  In other words, we sum up all the coefficients which are coordinatewise less or equal to J and we demand that this sum is nonnegative.  We do this for all J.  It is a lemma, proved in my paper, that Q\u22650 on [0,1]^5 provided that Q is WPD.";

	S=S+"\n\nThe converse is false, and it is very unlikely that a non-negative polynomial on [0,1]^5 is WPD.  So, to certify Q, we use a divide-and-conquer algorithm based on the WPD criterion.  The input to our algoritm is a pair (G,I) where G is a Poly5 and I is some non-decreasing integer sequence, which we call `the age'.  The age I determines a coordinate direction: it is the index of the leftmost smallest number. For instance (2,2,1,1,1) determines the 3rd coordinate direction.  The successor of I is the age obtained by incrementing the leftmost smallest entry. So, the successof of (2,2,1,1,1) is (2,2,2,1,1).  The successor of (2,2,2,1,1) is (2,2,2,2,1).  The successor of (2,2,2,2,2) is (3,2,2,2,2).  And so on.";

	S=S+"\n\nGiven a pair (G,I) we let k be the determined coordinate direction.  For ease of notation we will explain the situation when k=1.  Let H1 be the homothety (pure dilation) which carries the left half\n\n[0,1/2]x[0,1]^4\n\nTo [0,1]^5.  Let R be the reflection which carries the right half of [0,1]^5 to the left half.  Let H2=H1R.  Let G1=GH1 and G2=GH2.  Let I1 and I2 both be the successor of I.  The subdivision of (G,I) is (G1,I1) and (G2,I2).  Note that G\u22650 on [0,1]^5 if and only if G1\u22650 and G2\u22650 on [0,1]^5.";

	S=S+"\n\nThe algorithm starts with a list LIST of Poly5 pairs.  Initially the list consists of the single element (Q,0) where 0 stands for (0,0,0,0,0).  At any stage of the algorithm, I take the first pair (G,I) on the list and test whether G is WPD. If G is WPD, I eliminate (G,I) from LIST.  Otherwise, I replace (G,I) with (G1,I1) and (G2,I2) and continue.  If LIST ever becomes empty, I have a proof that G\u22650 on [0,1]^5.";

	S=S+"\n\nAt each step of the algorithm, the program also tests whether a given polynomial is negative at the origin.  If this happens, then we have a proof that the original polynomial is NOT non-negative in the given simplex.";

	S=S+"\n\nI have a calculation monitor which shows the age of the first member of LIST.  So, when you run the algorithm, you can see how well it is proceeding.  I decide to terminate the algorithm when some age reaches (N,N,N,N,N), so as to avoid an infinite loop in case the initial function is non-negative but not provably so with our algorithm.  One can easily construct examples of such polynomials, e.g. (x-y)^2, but they do not occur in our program.  I set the limit at N=6 but you can change this if you like.";





        D.setExplain(S);
        D.repaint();   
	D.Y0=0;
        D.Y1=0;

    }



    public static void single(DocumentCanvas D) {
	String S="batch option: single";

	S=S+"\n\nThis selection causes the positive dominance algorithm to run with the single polynomial you have selected using the Function Manager and the Simplex Manager.  You should read the documentation for those control panels to see how to select a polynomial.";

        D.setExplain(S);
        D.repaint();   
	D.Y0=0;
        D.Y1=0;

    }

    public static void group(DocumentCanvas D) {
	String S="batch option: group";

	S=S+"\n\nThis selection causes the positive dominance algorithm (PDA) to process a whole group of polynomials. This option works with the 12-simplex partition and the 48-simplex partition.  You can use the '1'-key on the keyboard to select certain of the simplices. The squares turn blue when you move the cursor over them and press '1'. (You de-select the squares by pressing '0'.  This turns them black again.)";

	S=S+"\n\nAlternatively, you can first run an experiment in the experiment mode, and this may select some of the simplices.  To learn more about this option, read the information about the experiment mode.";

	S=S+"\n\nIn either case, the algorithm while running recolors the squares of the simplex manager according to the following scheme:\n\nyellow: currently testing\ngreen: pass\ngrey: test terminated without success\nred: function negative at some point in simplex.\n\nIf you move the cursor over a green (i.e. already passed) square and press i, the program will print out the number of steps the PDA took.";

	S=S+"\n\nThere is one funny thing about the group mode.  The polynomials are tested in a particular order which does not look natural as the squares are colored on the screen.  This is an artifact of the was we indexed the functions.  So, if you watch the algorithm, it may appear at various times that it has skipped some polynomials on the list. But, don't worry, the algorithm will reach them eventually.";

        D.setExplain(S);
        D.repaint();   
	D.Y0=0;
        D.Y1=0;

    }

    public static void saveNo(DocumentCanvas D) {
	String S="save option: no";

	S=S+"\n\nThis turns off the feature which saves the polynomials to a file.  The Yes option has more information about this.";

        D.setExplain(S);
        D.repaint();   
	D.Y0=0;
        D.Y1=0;

    }

    public static void saveYes(DocumentCanvas D) {
	String S="save option: yes";

	S=S+"\n\nThis turns on the feature which saves the polynomials to a file.  When this option is on, and you are using the single mode, the program saves the input data to the file save_polys.  The input data is as follows:";

	S=S+"\n\nThe vertices of the simplex S.";
	S=S+"\n\nThe coefficients (a,b) of the combination P=(a)f + (b)df.";
	S=S+"\n\nThe binary vector V determining the directional derivative df=D_V(f).";
	S=S+"\n\nThe polynomial P.";
	S=S+"\n\nThe cube-transformed polynomial Q=PF.";
	S=S+"\n\nThe file save_polys is a Mathematica friendly file in the sense that it produces lists of integers which Mathematica can then convert (with some easy auxiliary routines) to polynomials.";

        D.setExplain(S);
        D.repaint();   
	D.Y0=0;
        D.Y1=0;

    }


    public static void tolerance(DocumentCanvas D) {
	String S="tolerance control";
	S=S+"\n\nThe positive dominance algorithm fails on a polynomial if the age ever reaches (N,N,N,N,N). Here N is the value of the magenta arrow keys.  We think that the choice N=6 is a good setting for this. When this happens, it is a good indication that the algorithm is not going to halt.";

        D.setExplain(S);
        D.repaint();   
	D.Y0=0;
        D.Y1=0;

    }


    public static void monitor(DocumentCanvas D) {
	String S="calculation monitor";
	S=S+"\n\nThis display monitors the progress of the positive dominance algorithm.  The program displays the subdivision age of the current polynomial, the total elapsed time, the number of steps, and the progress.  There are several fine points here.";

	S=S+"\n\nThe elapsed time is measured from the beginning of when the program is launched.";

	S=S+"\n\nThe total number of steps resets each time one of the initial polynomials is passed or failed. If you are running the program in group mode, the monitor erases the information about the number of steps each time it starts on a new initial polynomial. However, you can access the number of steps for any given polynomial by pressing the 'i' key (for info) over any green square on the simplex manager.  Then, the program will print out the number of steps it took to pass the polynomial corresponding to that square.";

S=S+"\n\nThe progress is measured in terms of the total volume of the polynomial pairs which have been deemed weak positive dominant.  The volume of a polynomial pair (G,I)$ is the power\n\n(1/2)^(i1+...+i5)\n\nWhen the calculation finishes (with success) the total volume for each initial polynomial is 1.  If N polynomials are tested, the final total volume (assuming complete success) will be N.";

        D.setExplain(S);
        D.repaint();   
	D.Y0=0;
        D.Y1=0;

    }




}