import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.awt.geom.*;


public class FunctionManager {
    SelectInteger[] LIN=new SelectInteger[2];
    int X,Y;
    int[][] DIFF=new int[4][4];
    int TRIPOD[]={1,1,1,1};
    int[] OPP1={0,0,0,0};
    int[] OPP2={0,0,0,0};
    Lever DIFF0;

    public FunctionManager(int x,int y) {
	X=x;
	Y=y;
	LIN[0]=new SelectInteger(x+20,y+35,40,20,0,-50,50,1);
	LIN[1]=new SelectInteger(x+150,y+35,40,20,0,-50,50,1);
	for(int i=0;i<4;++i) {
	    for(int j=0;j<4;++j) {
		DIFF[i][j]=0;
	    }
	}
	DIFF[0][1]=1;
	DIFF0=new Lever(X+5,Y+40,0,6);
	for(int i=0;i<0;++i) DIFF0.on[i]=0;
	DIFF0.on[0]=1;
    }


    public void render(Graphics2D g) {
	renderLin(g);
	renderDiff(g);
    }


    public void renderLin(Graphics2D g) {
        g.setColor(new Color(50,0,50));
	g.fillRect(X,Y,270,290);
        g.setColor(Color.white);
	g.drawRect(X,Y,270,290);
	Color C=new Color(50,100,255);
	LIN[0].render(g,C,Color.white,Color.white);
	LIN[1].render(g,C,Color.white,Color.white);
        g.setFont(new Font("Helvetica",Font.PLAIN,18));
	g.drawString("function manager",X+65,Y+20);
	g.setFont(new Font("Helvetica",Font.PLAIN,30));
	g.drawString("(",X+10,Y+53);
	g.drawString(")f",X+90,Y+53);
	g.drawString("+(",X+120,Y+53);
	g.drawString(")Df",X+220,Y+53);
    }

    public void renderDiff(Graphics2D g) {
	int[][] p={{20,270},{237,270},{135,198},{135,100}};
	g.setFont(new Font("Helvetica",Font.PLAIN,20));
	drawDecoration1(g,p);
	drawDecoration2(g,p);
	drawEdges(g,p);
	drawDots(g,p);
	DIFF0.render3(g,"",new Color(0,0,255));
	g.setStroke(new BasicStroke(1));
    }

    public void drawDecoration1(Graphics2D g,int[][] p) {
	g.setStroke(new BasicStroke(12));
	g.setColor(new Color(170,0,0));
	int a=determineCanonical();
	int i0=OPP1[0];
	int i1=OPP1[1];
	if((i0!=a)&&(i1!=a))
	g.drawLine(X+p[i0][0]+5,Y+p[i0][1]-7,X+p[i1][0]+5,Y+p[i1][1]-7);
	int i2=OPP1[2];
	int i3=OPP1[3];	
        if((i2!=a)&&(i3!=a))
	g.drawLine(X+p[i2][0]+5,Y+p[i2][1]-7,X+p[i3][0]+5,Y+p[i3][1]-7);

    }


    public void drawDecoration2(Graphics2D g,int[][] p) {

	g.setStroke(new BasicStroke(20));
	g.setColor(new Color(0,150,150));
	int i0=OPP2[0];
	int i1=OPP2[1];
	g.drawLine(X+p[i0][0]+5,Y+p[i0][1]-7,X+p[i1][0]+5,Y+p[i1][1]-7);
	int i2=OPP2[2];
	int i3=OPP2[3];
	g.drawLine(X+p[i2][0]+5,Y+p[i2][1]-7,X+p[i3][0]+5,Y+p[i3][1]-7);

    }





      public void drawDots(Graphics2D g,int[][] p) {
	  int[] D={12,10,8,6};
	  int[] D0={5,3,2,1};
	  int[] D1={3,2,1,0};

          g.setStroke(new BasicStroke(1));
	  for(int i=0;i<4;++i) {
	      int x=D[3-TRIPOD[i]];
	      int x0=D0[3-TRIPOD[i]];
	      int x1=D1[3-TRIPOD[i]];
	      Integer I=new Integer(i);
	      g.setColor(new Color(0,140,0));
	      try{
                 boolean test=determineCanonical(i);
	         if(test==true) g.setColor(new Color(0,0,250));
	      }
	      catch(Exception e) {}
	      if(TRIPOD[i]==0) g.setColor(new Color(200,0,0));
              g.fillArc(X+p[i][0]-x-x0,Y+p[i][1]-3*x+x0,4*x,4*x,0,360);
	      g.setColor(Color.white);
	      g.drawArc(X+p[i][0]-x-x0,Y+p[i][1]-3*x+x0,4*x,4*x,0,360);
	      g.setFont(new Font("Helvetica",Font.PLAIN,10+2*x));
	      g.drawString(I.toString(),X+p[i][0]-x1,Y+p[i][1]+3+x1);
	  }

      }

    public int determineCanonical() {
	for(int i=0;i<4;++i) {
	    if(determineCanonical(i)==true) {
		if(TRIPOD[i]!=0) return(i);
	    }
	}
	return(-1);
    }


    public boolean determineCanonical(int a) {
	int b=-1;
	if(OPP2[0]==a) b=OPP2[1];
	if(OPP2[1]==a) b=OPP2[0];
	if(OPP2[2]==a) b=OPP2[3];
	if(OPP2[3]==a) b=OPP2[2];
	if(TRIPOD[a]>TRIPOD[b]) return(false);
	return(true);
    }





    public void drawEdges(Graphics2D g,int[][] p) {
	for(int i=0;i<4;++i) {
	    for(int j=i+1;j<4;++j) {
		Color C=new Color(0,0,255);
		int str=1;
		if(DIFF[i][j]==1) {
		    C=new Color(255,150,0);
		    str=5;
		}
		g.setStroke(new BasicStroke(str));
		g.setColor(C);
		g.drawLine(X+p[i][0]+5,Y+p[i][1]-7,X+p[j][0]+5,Y+p[j][1]-7);
	    }
	}
    }




    public void processDiff(Point P) {
	DIFF0.toggle(P);
	for(int i=0;i<4;++i) {
	    for(int j=i+1;j<4;++j) DIFF[i][j]=0;
	}
	int[][] k={{0,1},{0,2},{0,3},{1,2},{1,3},{2,3}};
	for(int i=0;i<6;++i) {
	    if(DIFF0.on[i]==1) {
		DIFF[k[i][0]][k[i][1]]=1;
	    }
	}
    }

    public int[] getDiff() {
	int[] q=new int[6];
	for(int i=0;i<6;++i) q[i]=DIFF0.on[i];
	return(q);
    }


    public Poly6 getFunction() {
	int c0=LIN[0].val;
	int c1=LIN[1].val;
	Poly6 P0=DataCM.f();
	int[] q=new int[6];
	for(int i=0;i<6;++i) q[i]=DIFF0.on[i];
	Poly6 P1=DataCM.df(q);
	P0=P0.scale(c0);
	P1=P1.scale(c1);
	Poly6 P2= Poly6.plus(P0,P1);
	return(P2);
    }

    public void process(Point P) {
	LIN[0].modify(P);
	LIN[1].modify(P);
	processDiff(P);
    }


}

